{*******************************************************}
{                                                       }
{   Demo project author : Gabriel Anass TAOUSSI         }
{                                                       }
{*******************************************************}

unit TriSurfaceChart3D;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMXTee.Engine,
  FMXTee.Procs, FMXTee.Chart, FMX.Controls3D, FMXTee.Chart3D,
  FMX.Controls.Presentation, FMX.StdCtrls, FMXTee.Series.Surface,
  FMXTee.Series.TriSurface, FMX.Viewport3D,
  FMXTee.Tools,

  FMXTee.Editor.Chart3D;

type
  TMyTriSurfaceSeries=class(TTriSurfaceSeries);

type
  TChartAccess=class(TCustomAxisPanel);

type
  TForm1 = class(TForm)
    Chart3DChart1: TChart;
    Chart3D1: TChart3D;
    Viewport3D1: TViewport3D;
    Button1: TButton;
    Timer1: TTimer;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    Navigator : TMouse3D;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.FormCreate(Sender: TObject);
begin
  with Chart3DChart1 do
  begin
    { Chart speed tricks }
    BevelOuter       :=bvNone;
    BufferedDisplay  :=True;
    ClipPoints       :=False;
    Axes.FastCalc    :=True;  // <-- bypass overflow checkings...
    Title.Hide;
    Legend.Hide;
    Walls.Left.Hide;
    Hover.Visible := false;
    TChartAccess(Chart3DChart1).ParallelThreads:=TTeeCPU.NumberOfProcessors;
  end;


  var Series1 := TMyTriSurfaceSeries.Create(Chart3DChart1);
  { Series speed tricks }
  Series1.Pen.Hide;
  Series1.FastBrush                    := true;
  TMyTriSurfaceSeries(Series1).Reuse3D := true;

  { Other configs }
  Series1.CacheTriangles         := true;
  Series1.Selected.Hover.Visible := False;
  Series1.Brush.Kind             := TBrushKind.Solid;
  Series1.Transparency           := 0;
  Series1.PaletteStyle           := TTeePaletteStyle.psRainbow;
  Series1.UseColorRange          := False;
  Series1.UsePalette             := true;
  Series1.XValues.Name           := 'X';
  Series1.YValues.Name           := 'Y';
  Series1.ZValues.Name           := 'Z';
  Series1.XValues.Order          := loNone;
  Series1.YValues.Order          := loNone;
  Series1.ZValues.Order          := loNone;

  Series1.FillSampleValues(3600); // This is the lowest acceptable sample count
  Chart3DChart1.AddSeries(Series1);

  Series1.Active  := true;
  Series1.Visible := true;
  Series1.Repaint;
  Chart3DChart1.Repaint;

  Navigator:=TMouse3D.Create(Chart3D1);

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Navigator.free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Timer1.Enabled := false;
  Navigator.free;
  TChart3DEditor.Edit(Self, Chart3D1);
  Navigator:=TMouse3D.Create(Chart3D1);
  Timer1.Enabled := true;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False;
  With Chart3DChart1.View3DOptions do
  begin

    Rotation:=Rotation+1;
    if Rotation>360 then Rotation:=Rotation-360;
  end;
  Timer1.Enabled:=True;
end;

end.
